//Game Header
//All game specific code goes here
//Created 3/26/06 by Adam Sepanski

#ifndef _GAME_H
#define _GAME_H

//includes
//DirectX headers
#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr9.h>
#include <dsound.h>
#include <dinput.h>
#include <windows.h>
//Regular headers
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
//Created headers
#include "DXGraphics.H"
#include "DXAudio.h"
#include "DXInput.h"

//application title
#define APPTITLE "Kid Kombat"

#define SCREEN_WIDTH 800
#define SCREEN_HEIGHT 600

//Take Keyboard Input
#define KEY_DOWN(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)
#define KEY_UP(vk_code)((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)

//enumeration for directions
enum Direction{WEST=0,NORTHWEST,NORTH,NORTHEAST,EAST,SOUTHEAST,SOUTH,SOUTHWEST};

//sprite structure
typedef struct
{
	int x,y;//position
	int width,height;//size
	int vx,vy;//velocity
	int curframe,lastframe;//number of frames
	unsigned long int animdelay,animcount;//how long between frames
	int direction;//direction sprite is facing (enumerated)
	LPDIRECT3DTEXTURE9 texture;//texture to store sprite image
	RECT rectsource;
	bool visible;
	int alivetime;
}SPRITE;

//function prototypes
int Game_Init(HWND);
void Game_Run(HWND);
void Game_End(HWND);

void SetVelocityByDirection(SPRITE *sprite, int vx,int vy);
void CollisionWithWalls(SPRITE *sprite);
void CollisionAirplaneWithWalls(SPRITE *airplane);
void CollisionPlayerWithObject(SPRITE *sprite,SPRITE *object);
void CollisionAirplaneWithObject(SPRITE *airplane, SPRITE *object);
int CollisionPlayerWithAirplane(SPRITE *player, SPRITE *airplane);

#endif